osg::Program::ProgramObjects Struct Reference

`#include <Program>`

Inheritance diagram for osg::Program::ProgramObjects:

## Public Types

typedef std::vector< osg::ref_ptr< PerContextProgram > > | PerContextPrograms

## Public Member Functions

| ProgramObjects (const Program *program, unsigned int contextID)
PerContextProgram * | getPCP (const std::string &defineStr) const
PerContextProgram * | createPerContextProgram (const std::string &defineStr)
void | requestLink ()
void | addShaderToAttach (Shader *shader)
void | addShaderToDetach (Shader *shader)
bool | getGlProgramInfoLog (std::string &log) const
Public Member Functions inherited from osg::GraphicsObject
| GraphicsObject ()
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
virtual void | setThreadSafeRefUnref (bool)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Public Attributes

unsigned int | _contextID
const Program * | _program
PerContextPrograms | _perContextPrograms

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Member Functions inherited from osg::GraphicsObject
virtual | ~GraphicsObject ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Member Typedef Documentation

## PerContextPrograms

typedef std::vector< osg::ref_ptr<PerContextProgram> > osg::Program::ProgramObjects::PerContextPrograms

## Constructor & Destructor Documentation

## ProgramObjects()

osg::Program::ProgramObjects::ProgramObjects | ( | const Program * | program,
|  | unsigned int | contextID )

References osg::Program::Program().

## Member Function Documentation

## addShaderToAttach()

void osg::Program::ProgramObjects::addShaderToAttach | ( | Shader * | shader | ) |

## addShaderToDetach()

void osg::Program::ProgramObjects::addShaderToDetach | ( | Shader * | shader | ) |

## createPerContextProgram()

PerContextProgram * osg::Program::ProgramObjects::createPerContextProgram | ( | const std::string & | defineStr | ) |

## getGlProgramInfoLog()

bool osg::Program::ProgramObjects::getGlProgramInfoLog | ( | std::string & | log | ) | const

## getPCP()

PerContextProgram * osg::Program::ProgramObjects::getPCP | ( | const std::string & | defineStr | ) | const

## requestLink()

void osg::Program::ProgramObjects::requestLink | ( |  | ) |

## Member Data Documentation

## _contextID

unsigned int osg::Program::ProgramObjects::_contextID

## _perContextPrograms

PerContextPrograms osg::Program::ProgramObjects::_perContextPrograms

mutable

## _program

const Program* osg::Program::ProgramObjects::_program

The documentation for this struct was generated from the following file:

- osg/Program